/* pty.h ....... find a free pty/tty pair.  
 *               Inspired/stolen from the xterm source.
 *               NOTE: This is very likely to be highly non-portable.
 *               C. Scott Ananian <cananian@alumni.princeton.edu>
 *
 * $Id: pty.h,v 1.2 1997/12/13 08:39:01 cananian Exp $
 */

/* Hmm.  PTYs can be anywhere.... */

#ifndef PTYDEV
#define PTYDEV  "/dev/ptyxx"
#endif
#ifndef TTYDEV
#define TTYDEV  "/dev/ttyxx"
#endif

#ifndef PTYMAX
#define PTYMAX  (strlen(PTYDEV)+1)
#endif
#ifndef TTYMAX
#define TTYMAX  (strlen(TTYDEV)+1)
#endif

#ifndef PTYCHAR1
#define PTYCHAR1    "abcdepqrstuvwxyz"
#endif
#ifndef PTYCHAR2
#define PTYCHAR2    "0123456789abcdef"
#endif


/* Get pty/tty pair, put filename in ttydev, ptydev (which must be
 * at least PTYMAX characters long), and return file descriptor of
 * open pty.
 * Return value < 0 indicates failure.
 */
int getpseudotty(char *ttydev, char *ptydev);
