# This version MUST conincide with DHCP_VERSION of the dhcp package!
DHCP_BIND_VERSION     = 4.2.5-P1
# version of the BIND libraries contained in dhcp archive
DHCP_BIND_LIB_VERSION = 9.8.4-P2
DHCP_BIND_SITE        = http://ftp.isc.org/isc/dhcp/$(DHCP_BIND_VERSION)
DHCP_BIND_SOURCE      = dhcp-$(DHCP_BIND_VERSION).tar.gz
DHCP_BIND_SUBDIR      = bind/bind-$(DHCP_BIND_LIB_VERSION)
DHCP_BIND_INSTALL_STAGING = YES
DHCP_BIND_INSTALL_TARGET = NO
DHCP_BIND_EXPORT_DIR  = bind$(firstword $(subst .,$(space),$(DHCP_BIND_LIB_VERSION)))

DHCP_BIND_LICENSE = ISC
DHCP_BIND_LICENSE_FILES = LICENSE

DHCP_BIND_CONF_ENV = \
	ac_cv_file__dev_random=yes \
	BUILD_CC=$(HOSTCC) \
	BUILD_CFLAGS="$(HOST_CFLAGS)" \
	BUILD_CXXFLAGS="$(HOST_CXXFLAGS)" \
	BUILD_LDFLAGS="$(HOST_LDFLAGS)"

# from bind/Makefile.in
DHCP_BIND_CONF_OPTS = \
	--disable-kqueue \
	--disable-epoll \
	--disable-devpoll \
	--without-openssl \
	--without-libxml2 \
	--enable-exportlib \
	--enable-threads=no \
	--with-gssapi=no

define DHCP_BIND_EXTRACT_BIND
	tar xzvf $(@D)/bind/bind.tar.gz -C $(@D)/bind
endef

DHCP_BIND_POST_EXTRACT_HOOKS += DHCP_BIND_EXTRACT_BIND

define DHCP_BIND_BUILD_CMDS
	+$(TARGET_MAKE_ENV) $(MAKE1) -C $(DHCP_BIND_SRCDIR)/lib/export
endef

define DHCP_BIND_INSTALL_STAGING_CMDS
	+$(TARGET_MAKE_ENV) $(MAKE1) $(DHCP_BIND_INSTALL_STAGING_OPTS) -C $(DHCP_BIND_SRCDIR)/lib/export install
endef

$(eval $(autotools-package))
