GUTENPRINT_VERSION_MAJOR = 5.2
GUTENPRINT_VERSION = $(GUTENPRINT_VERSION_MAJOR).9
GUTENPRINT_SITE = http://downloads.sourceforge.net/project/gimp-print/gutenprint-$(GUTENPRINT_VERSION_MAJOR)/$(GUTENPRINT_VERSION)
GUTENPRINT_SOURCE = gutenprint-$(GUTENPRINT_VERSION).tar.bz2
GUTENPRINT_LICENSE = GPLv2+
GUTENPRINT_LICENSE_FILES = COPYING

# Needed, as we touch Makefile.am
GUTENPRINT_AUTORECONF = YES

GUTENPRINT_DEPENDENCIES = cups host-pkgconf host-flex host-bison \
	$(if $(BR2_PACKAGE_LIBICONV),libiconv)

define GUTENPRINT_AUTORECONF
	cd $(@D) && $(HOST_MAKE_ENV) NOCONFIGURE=1 sh ./autogen.sh
endef
GUTENPRINT_PRE_CONFIGURE_HOOKS += GUTENPRINT_AUTORECONF

GUTENPRINT_CONF_ENV = ac_cv_path_CUPS_CONFIG=$(STAGING_DIR)/usr/bin/cups-config \
	ac_cv_path_IJS_CONFIG=""

GUTENPRINT_CONF_OPTS = --disable-libgutenprintui2 \
                      --disable-samples \
                      --without-doc \
                      --without-ghostscript \
                      --without-modules \
                      --without-readline \
                      --without-gimp2 \
                      --without-foomatic \
                      --without-foomatic3 \
                      --enable-escputil \
                      --disable-test \
                      --disable-testpattern \
                      --without-cups \
                      --with-sysroot="$(STAGING_DIR)" \
                      --disable-cups-ppds

$(eval $(autotools-package))
