################################################################################
#
# isdn-firmware
#
################################################################################

ISDN_FIRMWARE_VERSION = 3.2p1
ISDN_FIRMWARE_SITE = ftp://ftp.isdn4linux.de/pub/isdn4linux/utils/
ISDN_FIRMWARE_SOURCE = isdn4k-utils.v$(ISDN_FIRMWARE_VERSION).tar.bz2

ISDN_FIRMWARE_FILES += isdn4k-utils/hisax/ISAR.BIN
ISDN_FIRMWARE_LICENSE += GPLv2+
ISDN_FIRMWARE_LICENSE_FILES += COPYING

define ISDN_FIRMWARE_EXTRACT_CMDS
$(INFLATE$(suffix $(ISDN_FIRMWARE_SOURCE))) $(DL_DIR)/$(ISDN_FIRMWARE_SOURCE) | \
   $(TAR) $(TAR_STRIP_COMPONENTS)=2 -C $(@D) $(TAR_OPTIONS) -
endef

define ISDN_FIRMWARE_INSTALL_TARGET_CMDS
   mkdir -p $(TARGET_DIR)/lib/firmware/isdn
   $(TAR) c -C $(@D) $(notdir $(ISDN_FIRMWARE_FILES)) | \
      $(TAR) x -C $(TARGET_DIR)/lib/firmware/isdn
endef

$(eval $(generic-package))
