################################################################################
#
# lttng-modules
#
################################################################################

ifeq ($(LINUX),)

LTTNG_MODULES_VERSION = 2.5.1
LTTNG_MODULES_SITE = http://lttng.org/files/lttng-modules
LTTNG_MODULES_SOURCE = lttng-modules-$(LTTNG_MODULES_VERSION).tar.bz2
LTTNG_MODULES_LICENSE = LGPLv2.1/GPLv2 for kernel modules; MIT for lib/bitfield.h and lib/prio_heap/*
LTTNG_MODULES_LICENSE_FILES = lgpl-2.1.txt gpl-2.0.txt mit-license.txt LICENSE
LTTNG_MODULES_DEPENDENCIES =

$(eval $(generic-package))
$(call ITERATED_CALL,LINUX_REINCLUDE_MAKEFILE,$(LINUX_DEPENDENCIES))

else

BR2_PACKAGE_LTTNG_MODULES_$(LINUX) := $(BR2_PACKAGE_LTTNG_MODULES)

LTTNG_MODULES_$(LINUX)_VERSION = $(LTTNG_MODULES_VERSION)
LTTNG_MODULES_$(LINUX)_SITE    = $(LTTNG_MODULES_SITE)
LTTNG_MODULES_$(LINUX)_SOURCE  = $(LTTNG_MODULES_SOURCE)
LTTNG_MODULES_$(LINUX)_LICENSE = $(LTTNG_MODULES_LICENSE)
LTTNG_MODULES_$(LINUX)_LICENSE_FILES = $(LTTNG_MODULES_LICENSE_FILES)
LTTNG_MODULES_$(LINUX)_DEPENDENCIES := lttng-modules $($(LINUX)_NAME)

define LTTNG_MODULES_$(LINUX)_BUILD_CMDS
	+$(MAKE) -C $(@D) $($(LINUX)_MAKE_FLAGS) KERNELDIR=$($(LINUX)_DIR)
endef

define LTTNG_MODULES_$(LINUX)_INSTALL_TARGET_CMDS
	+$(MAKE) -C $(@D) $($(LINUX)_MAKE_FLAGS) KERNELDIR=$($(LINUX)_DIR) modules_install
	rm $(TARGET_DIR)/lib/modules/$($(LINUX)_VERSION_PROBED)/modules.*
endef

$(eval $(call generic-package,lttng-modules-$($(LINUX)_NAME)))

$(LTTNG_MODULES_$(LINUX)_TARGET_BUILD): LINUX := $(LINUX)
$(LTTNG_MODULES_$(LINUX)_TARGET_INSTALL_TARGET): LINUX := $(LINUX)

ifeq ($(BR2_PACKAGE_LTTNG_MODULES),y)
$(eval $(LINUX)_MODULES += lttng-modules-$($(LINUX)_NAME))
endif

endif
