################################################################################
#
# ocf-linux
#
################################################################################

OCF_LINUX_VERSION = 20120127
OCF_LINUX_SITE = http://downloads.sourceforge.net/project/ocf-linux/ocf-linux/$(OCF_LINUX_VERSION)
OCF_LINUX_INSTALL_STAGING = YES

ifeq ($(BR2_PACKAGE_OCF_LINUX),y)
define OCF_LINUX_BUILD_CMDS
	ln -s ../ocf $(@D)/crypto-tools/crypto
	+$(MAKE) CC=$(TARGET_CC) CFLAGS="$(TARGET_CFLAGS) -I ." \
		-C $(@D)/crypto-tools cryptotest cmactest
endef
endif

define OCF_LINUX_INSTALL_TARGET_CMDS
	$(INSTALL) -D $(@D)/crypto-tools/cryptotest $(TARGET_DIR)/usr/bin/cryptotest
	$(INSTALL) -D $(@D)/crypto-tools/cmactest $(TARGET_DIR)/usr/bin/cmactest
endef

define OCF_LINUX_INSTALL_STAGING_CMDS
	$(INSTALL) -D -m 644 $(@D)/ocf/cryptodev.h \
		$(STAGING_DIR)/usr/include/crypto/cryptodev.h
endef

$(eval $(generic-package))
