################################################################################
#
# wget
#
################################################################################

WGET_VERSION = 1.16
WGET_SOURCE = wget-$(WGET_VERSION).tar.xz
WGET_SITE = $(BR2_GNU_MIRROR)/wget
WGET_LICENSE = GPLv3+
WGET_LICENSE_FILES = COPYING

WGET_CONF_ENV = ac_cv_header_pcre_h=no

ifeq ($(BR2_PACKAGE_GNUTLS),y)
	WGET_CONF_OPTS += --with-ssl=gnutls \
		--with-libgnutls-prefix=$(STAGING_DIR)
	WGET_DEPENDENCIES += gnutls
endif

ifeq ($(BR2_PACKAGE_OPENSSL),y)
	WGET_CONF_OPTS += --with-ssl=openssl --with-libssl-prefix=$(STAGING_DIR)
	WGET_DEPENDENCIES += openssl
endif

ifeq ($(BR2_PACKAGE_UTIL_LINUX_LIBUUID),y)
	WGET_DEPENDENCIES += util-linux
endif

ifeq ($(BR2_PACKAGE_LIBICONV),y)
	WGET_DEPENDENCIES += libiconv
endif

# --with-ssl is default
ifneq ($(BR2_PACKAGE_GNUTLS),y)
ifneq ($(BR2_PACKAGE_OPENSSL),y)
	WGET_CONF_OPTS += --without-ssl
endif
endif

$(eval $(autotools-package))
