/*----------------------------------------------------------------------------
 *  circd server for Linux
 *
 *  Copyright (c) 2005-2016 - Oliver Dawid, fli4l-Team <team@fli4l.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *----------------------------------------------------------------------------
 */

#define EXEC_PREFIX "usr/local/bin/"

#define IMOND_TIMEOUT 1000
#define IMOND_PORT 5000

#define PASSWORD_STATE_NONE   0x00
#define PASSWORD_STATE_NORMAL 0x01
#define PASSWORD_STATE_ADMIN  0x02

#define TRANSFER_BUFFER_SIZE 1024

#define NAK_CHAR   '\025'
#define NAK_STRING "\025"
#define ACK_STRING "\006"

#define ERR -1
#define OK   0

#define TRUE  1
#define FALSE 0

#define HELP_COMMANDSBYLINE 3
#define HELP_COMMANDWIDTH "22"

#define RAW 1
#define QUIT 2

#define ADMIN_MODE 4

#define DIALMODE_OFF    0
#define DIALMODE_AUTO   1
#define DIALMODE_MANUAL 2

#define PROTOCOL_VERSION 13
#define IMOND_VERSION "0.50"

#define MAX_ARGUMENTS 16
#define LOG_BUF_SIZE 1024

#define HOURS_PER_DAY 24
#define DAYS_PER_WEEK 7
#define SUNDAY 0

#define TIMEOUT_CALC_IOBYTES 1000
#define TIMEOUT_CHECK_LCR 10000

#define UPTIME_MEASURE_TIME 60
