/**
 * \file syslog.c
 * \brief syslog functions
 * \version $Revision:$
 * \date Last change: $Date:$
 * \author Oliver Dawid
 * \author Last change by: $Author:$
 */

/*----------------------------------------------------------------------------
 *  circd server for Linux
 *
 *  Copyright (c) 2005-2016 - Oliver Dawid, fli4l-Team <team@fli4l.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *----------------------------------------------------------------------------
 */

#include "circd.h"

static int log_to_syslog = 0;

void circd_open_syslog (void)
{
	openlog("circd", LOG_PID|LOG_PERROR, LOG_USER);
	log_to_syslog = 1;
}

void circd_syslog (int log_level, const char *fmt, ...)
{
	va_list ap;
	char msg_buf[LOG_BUF_SIZE];
	
	va_start(ap, fmt);
	if (log_to_syslog) {
		vsprintf(msg_buf, fmt, ap);
		syslog(log_level, "%s", msg_buf);
	} else {
		vfprintf(stderr, fmt, ap);
		fprintf(stderr, "\n");
	}
	va_end (ap);
}

